<h2>1 - Transitions</h2>

<p>A very simple application that has 2 or 3 HTML files which have
transitions to each-other and have some links to external pages.
Explains what are the transitions and the difference between the
transitions and the links. Explains how to debug transitions.</p>
<br />
<span class="button">
  <a href="{{SAPPS_URL}}app1/" target="_blank">Test</a>
</span>
<span class="button">
  <a href= "{{SAPPS_URL}}app1/browse.php" target="_blank">Browse</a>
</span>
<!--#
<span class="button">
  <a href= "{{HOME_URL}}get/app1.tar.gz">Download</a>
</span>
#-->
<br />
<hr />

<h3><a name="toc">Table of Contents</a></h3>

<ul>
  <li><a href="#goto">Transitions by GoTo()</a></li>

  <li><a href="#external">External Pages</a></li>

  <li><a href="#structure">The Structure of the Application</a></li>

  <li>
    <a href="#exercises">Exercises</a>

    <ol>
      <li><a href="#exercise_1">Create a new application</a></li>

      <li><a href="#exercise_2">Move an application to another location</a></li>

      <li><a href="#exercise_3">Debugging Transitions</a></li>

      <li><a href="#exercise_4">Add a New Page to the Application</a></li>

      <li><a href="#exercise_5">Set the initial page of the application</a></li>

      <li><a href="#exercise_6">Put the pages in another folder</a></li>
    </ol>
  </li>

  <li><a href="#experiments">Experiments and questions</a></li>
</ul>
<hr />

<p><a name="goto"></a></p>

<h3>Transitions by Goto</h3>

<p>The <strong>phpWebApp</strong> thinks of a web application as 
a state machine, where each state is a web page. Each time the browser 
loads something new in its window, you see a snapshot of the application 
in a certain state. Transitions from one state (page) of the application 
to another are done by using the javascript function
<strong>GoTo('page.html')</strong>. This function is declared by
the framework itself and is included automatically at the head of
each page of the application. The parameter given to
<strong>GoTo()</strong> is the target page, i.e. the next page that 
will be displayed by the framework.</p>

<p>In real applications, usually the link calls a
<em>JavaScript</em> function, and this function makes the
transition by calling <strong>GoTo()</strong>. So, the application
has a chance to make any error checking, input data validations
etc. before making the transition to the other page.</p>

<p><a href="javascript:codeReview('{{SAPPS_PATH}}app1/page1.html','18,57,58')">
See the code</a> of the first page and notice how the
<strong>GoTo()</strong> is used.
<br />
If you have not tested the application yet, please 
<a href="{{SAPPS_URL}}app1/" target="_blank">test it</a> now and pay
attention to how the <strong>GoTo()</strong> is used.</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="external"></a>

<h3>External Pages</h3>

<p>The external pages are HTML pages that are outside the
application. They are linked as usually in HTML, without using
transitions and the function <strong>GoTo()</strong>. These pages
are not part of the application, they are either plain HTML pages
or pages of other applications.</p>

<p>While in an external page, you cannot go back to a page of the
application by using the function <strong>GoTo()</strong> because
it is undefined. You can only go back to the same page of the
application from which you got out by pressing the button
<strong>back</strong> in the browser (or calling the JS function
<em>history.back()</em>).</p>

<p>If you open a page of the application by linking (as an external
page), not by a <strong>GoTo()</strong> transition, then it will
not behave as a page of the application (because the 
<strong>GoTo()</strong> function and other framework related things
are not included in it).</p>

<p>See an 
<a href="javascript:codeReview('{{SAPPS_PATH}}app1/page2.html','23,24','15-32')">
example</a> of linking to external pages.</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="structure"></a>

<h3>The Structure of the Application</h3>

<p>Each application build with <strong>phpWebApp</strong> framework
must have some files that are required by the framework. Besides
them it should also have its own files. The required files are almost 
the same for every application. The <em>application</em> files and 
folders are created by the application developer and they are different 
for each application.</p>

<p>If you have not yet browsed the application, then 
<a href="{{SAPPS_URL}}app1/browse.php" target="_blank">browse it</a>
now.</p>

<p>The files required by the framework are:</p>
<pre>
  config/                 -- configuration files for the application
      const.Paths.php     -- constants of paths used in the application
      const.Options.php   -- constants that change the behavior of the app
      const.Debug.php     -- constants that are used for debugging the app

  index.php               -- standard framework file
  webapp.php              -- standard framework file
</pre>
<br />

<p>The application files and folders are:</p>
<pre>
    img/
        back.png
        home.png
        state_diagram.png
    page1.html
    page2.html
    page3.html
    styles.css
</pre>
<br />

<p>The file <em>browse.php</em> is not required by the framework
and is almost the same for each application. It is usually
used during the development of the application to preview how the
templates and weboxes look like. The file <em>external_page.html</em>
does not belong neither to the framework nor to the application; it
just happens to be in the folder of the application.</p>

<p>The files <em>index.php</em> and <em>webapp.php</em> are the same
for each application, you don't need to modify them and usually they
should not be touched. In the <em>config</em> files, there are three
constants that must be set for each new application, and the rest of
them are optional. These constants are: <strong>WEBAPP_PATH</strong>
and <strong>TPL</strong> in 
<a href="javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Paths.php','5,6')">const.Paths.php</a>, 
and <strong>FIRSTPAGE</strong> in 
<a href="javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Options.php','30-34','22-42')">const.Options.php</a>
</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="exercises"></a>

<h3>Exercises</h3>

<p>To be able to try the exercises you have to install the
framework and the sample applications in your computer or somewhere
where you can make changes.</p>

<a name="exercise_1"></a>

<h4>1 - Create a new application</h4>

<p>In this exercise you will create another application which is
the same as <strong>app1</strong> but has a different name,
<strong>app1_test</strong>. Follow these steps:</p>

<ol>
  <li>Copy the folder <em>app1</em> to the folder <em>app1_test</em>:<br /> 
  <kbd>$ cp -R app1 app1_test</kbd></li>

  <li>That was all, open the application <em>app1_test/</em> in browser 
  to test it. It should work.</li>
</ol>

<a name="exercise_2"></a>

<h4>2 - Move an application to another location</h4>

<p>In this exercise you will move the application <em>app1_test</em> to
<em>test/app1_test</em>.</p>

<ol>
  <li>Create the folder <em>test</em> and move <em>app1_test</em> to it: <br />
  <kbd>$ mkdir test <br /> $ mv app1_test test</kbd></li>

  <li>Edit the file <em>test/app1_test/config/<a href="javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Paths.php','5')">const.Paths.php</a></em>
  so that the constant <strong>WEBAPP_PATH</strong> is set to
  <strong>UP_PATH."../web_app/"</strong>.</li>

  <li>Open the application <em>test/app1_test/</em> in browser to test
  it; it should work.</li>
</ol>

<p><strong>WEBAPP_PATH</strong> is the path of the phpWebApp framework
and tells the application where to find the framework. This constant
is used by the file <strong>webapp.php</strong> to include the
framework classes and modules. The constant <strong>UP_PATH</strong>
which is defined in <strong>webapp.php</strong>, contains the parent
folder of the application (app1_test) folder.</p>

<p>In this example it is set as a relative path, but it can be set
as an absolute path as well, e.g. <em>/var/www/html/web_app/</em>.
In this case you don't have to worry about changing it when moving
an application to another location.</p>

<a name="exercise_3"></a>

<h4>3 - Debugging Transitions</h4>

<ol>
  <li>Edit the file 
  <a href="javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Debug.php','27-31')">
  <em>config/const.Debug.php</em></a> and set the constant
  <strong>DEBUG_GOTO</strong> to <strong>true</strong>.</li>

  <li>Test the application and notice that each time that you make
  a transition you get an alert about it.</li>
</ol>

<a name="exercise_4"></a>

<h4>4 - Add a New Page to the Application</h4>

<ol>
  <li>Copy <em>page1.html</em> to <em>page4.html</em> and change its 
  title and content to <em>Page 4</em>. <br />
  <kbd>$ cd test/app1_test <br /> $ cp page1.html page4.html</kbd></li>

  <li>Change the links at the bottom of the pages to link to
  <em>page4.html</em> as well. You should link to it using the 
  <strong>GoTo()</strong> function.</li>

  <li>Test it.</li>
</ol>

<a name="exercise_5"></a>

<h4>5 - Set the initial page of the application</h4>

<ol>
  <li>Open the file <em>config/<a href=
  "javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Options.php','30-34')">const.Options.php</a></em> 
  and set the <strong>FIRSTPAGE</strong> variable to
  <strong>page2.html</strong>.</li>

  <li>Test the application and press the <em>Home</em> button.</li>
</ol>

<a name="exercise_6"></a>

<h4>6 - Put the pages in another folder</h4>

<p>In this exercise you will put all the pages of the application
in another folder.</p>

<ol>
  <li>Create a new folder named <em>pages</em>: <br />
  <kbd>$ mkdir pages</kbd></li>

  <li>Move all the pages to this folder: <br />
  <kbd>$ mv page*.html pages</kbd></li>

  <li>Open the file <em>config/<a href=
  "javascript:codeReview('{{SAPPS_PATH}}app1/config/const.Paths.php','6')">const.Paths.php</a></em>
  and set the constant <strong>TPL</strong>
  to <strong>APP_PATH."pages/"</strong>.</li>

  <li>Test the application. It should work.</li>
</ol>

<p>The constant <strong>TPL</strong> tells to framework where to
look for the pages (in the phpWebApp jargon pages are called
<em>templates</em> because they may contain <em>variables</em> and
other <em>extra tags</em> that are processed by the framework). When
you write <strong>GoTo('page1.html')</strong>, the framework looks for
<em>page1.html</em> in the <strong>TPL</strong>. The constant
<strong>APP_PATH</strong> is a predefined constant and it contains the
path of the application itself.</p>

<p>By convention, the names of the path constants have a
<strong>_PATH</strong> extension at the end, e.g. MENU_PATH,
TUTORIAL_PATH, etc. They represent paths in the server, e.g. TPL
may have the value: <em>/var/www/html/test/app1_test/pages/</em>. Their 
value always has a slash <strong>/</strong> at the end (by convention).</p>

<p>Another kind of constants used in the framework, the URL constants,
represent paths in the application starting from the DocumentRoot (the
part of the URL coming after the server name and before the file
name). By convention, they end with an <strong>_URL</strong> and their
value ends with a slash <strong>/</strong>. E.g. IMG_URL, JS_URL, etc.</p>

<span class="button"><a href="#toc">TOC</a></span>
<hr />

<a name="experiments"></a>

<h3>Experiments and questions</h3>

<p>Try to do these experiments and to answer these questions.</p>

<ol>
  <li>Move the <em>external_page.html</em> to the folder
  <em>pages</em> and see whether the link to it works. How you should
  change this link to make it work?</li>

  <li>Move the stylesheet <em>styles.css</em> to the folder
  <em>pages</em> and see whether it works. What changes you can do to
  make the application find the stylesheet?</li>

  <li>Rename the folder <em>img</em> to <em>images</em>. What changes
  you can do to make the application work?</li>
</ol>

<p><br />
<br />
<span class="button"><a href="#toc">TOC</a></span>
</p>
<hr />
